package action.gerente;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts2.ServletActionContext;

import utils.TimeUtil;
import action.BaseAction;
import beans.Curso;
import beans.Persona;
import beans.Pista;

import com.opensymphony.xwork2.ModelDriven;

import controler.CursoControler;
import controler.impl.CursoControlerImpl;

@SuppressWarnings("serial")
public class CreacionCursosAction extends BaseAction implements ModelDriven<Curso>{
	
	
	private String pagina = null;
	private Boolean popup = false;
	private List<Curso> cursos;
	private List<Pista> pistas;
	private List<Persona> profesores;
	Curso curso;

	private CursoControler cursoControler =  (CursoControler) applicationContext.getBean("cursoControler",CursoControlerImpl.class);
	
	  public String execute() {
		   		 
		  HttpServletRequest request = ServletActionContext.getRequest();
		  try{
		  pistas = cursoControler.getPistas();
		  profesores = cursoControler.getProfesores();
		 
		  
		  String idCurso = request.getParameter("idcurso"); 
		  curso=(Curso) sesion.get("cursoEnCreacion");
		  
		  if(idCurso!=null){
			  curso = cursoControler.getCurso(idCurso);
			  sesion.remove("cursoEnCreacion");
		  }
		
		  popup = false;
		  }catch(Exception e){
			  log.error(e);
			  e.printStackTrace();
		  }
		  return SUCCESS;

	   }
	  
	  public String grabar() {
		   
		  
		  try{
		  String volver = (String) sesion.get("volver");
		  
		  pagina = "nuevoCurso";
		  
		  String idPista = request.getParameter("selectPistas");
		  String idProfesor = request.getParameter("selectProfesores");
		  String horaInicio = request.getParameter("horaInicio");
		  String minutoInicio = request.getParameter("minutoInicio");
		  String horaFin = request.getParameter("horaFin");
		  String minutoFin = request.getParameter("minutoFin");
		  String diasCurso = request.getParameter("diasCurso");
		  int inicio = Integer.parseInt(horaInicio)+Integer.parseInt(minutoInicio);
		  int fin = Integer.parseInt(horaInicio)+Integer.parseInt(minutoFin);
		  sesion.put("cursoEnCreacion", curso);
		  if(curso.getNombre()==null||"".equals(curso.getNombre())){
			  popup=true;
			  addActionMessage("Debe poner un nombre al curso");
		  }else if(idPista==null||"0".equals(idPista)){
			  popup=true;
			  addActionMessage("Debe seleccionar una pista");
		  }else if(curso.getFechaInicio()==null){
			  popup=true;
			  addActionMessage("Debe seleccionar una fecha de inicio");  
		  }else if(curso.getFechaFin()==null){
			  popup=true;
			  addActionMessage("Debe seleccionar una fecha de fin");  
		  }else if(curso.getFechaInicio().after(curso.getFechaFin())){
			  popup=true;
			  addActionMessage("Debe seleccionar un intervalo de fechas correcto");  
		  }else if(idProfesor==null||"0".equals(idProfesor)){
			  popup=true;
			  addActionMessage("Debe seleccionar un profesor");  
		  }else if(curso.getPlazasDisponibles()==null){
			  popup=true;
			  addActionMessage("Debe seleccionar las plazas del curso");  
		  }else if(inicio>=fin){
			  popup=true;
			  addActionMessage("Debe seleccionar una hora correcta para el curso");
		  }else if(diasCurso==null){
			  popup=true;
			  addActionMessage("Debe seleccionar un da para el curso");
		  }else{
		  Pista pista = new Pista();
		  pista.setIdPista(Integer.parseInt(idPista));
		  curso.setPista(pista);
		  
		  Persona profesor = new Persona();
		  profesor.setIdPersona(Integer.parseInt(idProfesor));
		  curso.setProfesor(profesor);		  
		  
		  curso.setHoraIniCurso(TimeUtil.StringToHora(horaInicio, minutoInicio));
		  curso.setHoraFinCurso(TimeUtil.StringToHora(horaFin, minutoFin));
		  
		  String[] dias = diasCurso.split(";");
		   for(int i=0;i<dias.length;i++){
			   if("LUNES".equals(dias[i]))
				   curso.setLunes(Boolean.TRUE);
			   else
				   curso.setLunes(Boolean.FALSE);
			   
			   if("MARTES".equals(dias[i]))
				   curso.setMartes(Boolean.TRUE);
			   else
				   curso.setMartes(Boolean.FALSE);
			   
			   if("MIERCOLES".equals(dias[i]))
				   curso.setMiercoles(Boolean.TRUE);
			   else
				   curso.setMiercoles(Boolean.FALSE);
			   
			   if("JUEVES".equals(dias[i]))
				   curso.setJueves(Boolean.TRUE);
			   else
				   curso.setJueves(Boolean.FALSE);
			   
			   if("VIERNES".equals(dias[i]))
				   curso.setViernes(Boolean.TRUE);
			   else
				   curso.setViernes(Boolean.FALSE);
		   }
		  
		  cursoControler.guardarCurso(curso);
		  sesion.remove("cursoEnCreacion");
		  if("true".equals(volver)){
			   pagina = "modificarCurso";
			   sesion.remove("volver");
		   }
		  popup = true;
		  addActionMessage("Curso guardado correctamente");
		  log.info("Curso guardado correctamente con id: "+curso.getIdCurso());
		  }
		  }catch(Exception e){
			  log.error(e);
			  e.printStackTrace();
		  }
		  
		  return SUCCESS;

	   }
	  
	  public String listar() {
		 
		  try {
				cursos = cursoControler.getCursos();
			} catch (Exception e) {
				log.error(e);
				e.printStackTrace();
			}   
		  
		  popup = false;
		  
		  return SUCCESS;

	   }
	  
	  public String actualizar() {

		   String idCurso = request.getParameter("identificador");
		   if(idCurso==null){
			   pagina="modificarCurso";
			   popup=true;
			   addActionMessage("No ha seleccionado ningn curso");
			   return ERROR;
		   }
		   idCurso = idCurso.replace("/", "");
		 
		  pagina="nuevoCurso?idcurso="+idCurso;
		  sesion.put("volver", "true"); 
		  popup = false;
		  
		  return SUCCESS;

	   }
	  
	  public String borrar()  {

		  String idCurso = request.getParameter("identificador");
		   if(idCurso==null){
			   pagina="modificarCurso";
			   popup=true;
			   addActionMessage("No ha seleccionado ningn curso");
			   return ERROR;
		   }
		   idCurso = idCurso.replace("/", "");
		  
		  try {
			  curso = cursoControler.getCurso(idCurso);
			  cursoControler.borrarCurso(curso);
			} catch (Exception e) {
				log.error(e);
				e.printStackTrace();
			}
		  pagina="modificarCurso";
		  popup = true;
		  addActionMessage("Curso borrado correctamente");
		  log.info("Curso borrado correctamente con id: "+idCurso);
		  return SUCCESS;

	   }
	  

	public CursoControler getCursoControler() {
		return cursoControler;
	}
	
	public List<Curso> getCursos(){
		return cursos;
	}

	public List<Pista> getPistas() {
		return pistas;
	}
	

	public List<Persona> getProfesores() {
		return profesores;
	}

	public void setCursoControler(CursoControler cursoControler) {
		this.cursoControler = cursoControler;
	}

	public String getPagina() {
		return pagina;
	}

	public void setPagina(String pagina) {
		this.pagina = pagina;
	}

	public Boolean getPopup() {
		return popup;
	}

	public void setPopup(Boolean popup) {
		this.popup = popup;
	}

	public void setCurso(Curso curso) {
		this.curso = curso;
	}

	public Curso getCurso() {
		return curso;
	}

	@Override
	public Curso getModel() {
		return curso;
	} 

}
