package action.gerente;

import java.util.List;

import action.BaseAction;
import beans.Persona;

import com.opensymphony.xwork2.ModelDriven;

import controler.PersonaControler;
import controler.impl.PersonaControlerImpl;

@SuppressWarnings("serial")
public class CreacionPersonasAction extends BaseAction implements ModelDriven<Persona>{

	private String pagina = null;
	private Boolean popup = false;
	private List<Persona> personas;
	private List<String> roles;
	Persona persona;
	 
	PersonaControler personaControler =  (PersonaControler) applicationContext.getBean("personaControler",PersonaControlerImpl.class);

	
	  public String execute() {
		  try{
		  roles = personaControler.getRoles();
		  
		  String idPersona = (String) request.getParameter("idpersona");
		  persona = (Persona) sesion.get("personaEnCreacion");
		  if(idPersona!=null){
			  persona = personaControler.getPersona(idPersona);
			  sesion.remove("personaEnCreacion");
		  	} 
		 
		  popup = false;
		  }catch(Exception e){
			  log.error(e);
			  e.printStackTrace();
		  }
		  return SUCCESS;

	   }
	  
	  public String grabar() {
		  try{
		  String volver = (String) sesion.get("volver");
		 
		  pagina = "nuevaPersona";
		   
		  popup = true;
		  sesion.put("personaEnCreacion", persona);
		  if(persona.getNombre()==null||"".equals(persona.getNombre())){
			  addActionMessage("Debe indicar un nombre");
		  }else if(persona.getApellidos()==null||"".equals(persona.getApellidos())){
			  addActionMessage("Debe indicar los apellidos");
		  }
		  else if(persona.getDni()==null||"".equals(persona.getDni())){
			  addActionMessage("Debe indicar el dni del usuario");
		  }else if(persona.getPassword()==null||"".equals(persona.getPassword())){
			  addActionMessage("Debe indicar una contrasea");
		  }else{
			  personaControler.guardarPersona(persona);
			  sesion.remove("personaEnCreacion");
			  if("true".equals(volver)){
				   pagina = "modificarPersona";
				   sesion.remove("volver");
			   }
			  addActionMessage("Persona guardada correctamente");
			  log.info("Persona guardada correctamente con id: "+persona.getIdPersona());
		  }
		  }catch(Exception e){
			  log.error(e);
			  e.printStackTrace();
		  }
		  return SUCCESS;

	   }
	  
	  public String listar() {
		 
		  try {
				personas = personaControler.getPersonas();
			} catch (Exception e) {
				log.error(e);
				e.printStackTrace();
			}   
		  
		  popup = false;
		  
		  return SUCCESS;

	   }
	  
	  public String actualizar(){
	
		   String idPersona = request.getParameter("identificador");
		   if(idPersona==null){
			   pagina="modificarPersona";
			   popup=true;
			   addActionMessage("No ha seleccionado ninguna persona");
			   return ERROR;
		   }
		   idPersona = idPersona.replace("/", "");
		 
		  pagina="nuevaPersona?idpersona="+idPersona;
		  sesion.put("volver", "true"); 
		  popup = false;
		  
		  return SUCCESS;

	   }
	  
	  public String borrar() {
		 
		  String idPersona = request.getParameter("identificador");
		   if(idPersona==null){
			   pagina="modificarPersona";
			   popup=true;
			   addActionMessage("No ha seleccionado ninguna persona");
			   return ERROR;
		   }
		   idPersona = idPersona.replace("/", "");
		  
		  try {
			persona = personaControler.getPersona(idPersona);
			personaControler.borrarPersona(persona);
		  } catch (Exception e) {
				log.error(e);
				e.printStackTrace();
		  }
			 
		 
		  pagina="modificarPersona";
		  popup = true;
		  addActionMessage("Persona borrada correctamente");
		  log.info("Persona borrada correctamente con id: "+persona.getIdPersona());
		  return SUCCESS;

	   }

	public Persona getPersona() {
		return persona;
	}

	public void setPersona(Persona persona) {
		this.persona = persona;
	}

	public List<Persona> getPersonas(){
		return personas;
	}
	
	public List<String> getRoles(){
		return roles;
	}

	public PersonaControler getPersonaControler() {
		return personaControler;
	}

	public void setPersonaControler(PersonaControler personaControler) {
		this.personaControler = personaControler;
	}

	public String getPagina() {
		return pagina;
	}

	public void setPagina(String pagina) {
		this.pagina = pagina;
	}

	public Boolean getPopup() {
		return popup;
	}

	public void setPopup(Boolean popup) {
		this.popup = popup;
	}

	@Override
	public Persona getModel() {
		return persona;
	}
	
	
	
}
