package action.gerente;

import java.util.List;

import action.BaseAction;
import beans.Pista;

import com.opensymphony.xwork2.ModelDriven;

import controler.PistaControler;
import controler.impl.PistaControlerImpl;

@SuppressWarnings("serial")
public class CreacionPistasAction extends BaseAction implements ModelDriven<Pista>{
	
	
	private String pagina = null;
	private Boolean popup = false;
	private List<Pista> pistas;
	
	
	Pista pista = new Pista();
	
	PistaControler pistaControler =  (PistaControler) applicationContext.getBean("pistaControler",PistaControlerImpl.class);
	
	  public String execute() {
		  
		  String idPista = (String) request.getParameter("idpista");
		  if(idPista!=null){
			  try {
				pista = pistaControler.getPista(idPista);
				} catch (Exception e) {
					log.error(e);
					e.printStackTrace();
				}
		  	} 

		  popup = false;

		  return SUCCESS;

	   }
	  
	  public String grabar() throws Exception {
		  popup = true;
		  if(pista.getNombre()==null||"".equals(pista.getNombre())){
			  pagina="nuevaPista";
			  addActionMessage("Debe introducir un nombre de pista");
		  }else{
			  pistaControler.guardarPista(pista);
			  String volver = (String) sesion.get("volver");
			   if("true".equals(volver)){
				   pagina = "modificarPista";
				   sesion.remove("volver");
			   }else{
				   pagina = "nuevaPista";
			   }
			  addActionMessage("Pista guardada correctamente");
			  log.info("Pista guardada correctamente con id: "+pista.getIdPista());
		  }
		  return SUCCESS;

	   }
	  
	  public String listar() {
		 
		  try {
				pistas = pistaControler.getPistas();
			} catch (Exception e) {
				log.error(e);
				e.printStackTrace();
			}   
		  
		  popup = false;
		  
		  return SUCCESS;

	   }
	  
	  public String actualizar() throws Exception {

		   String idPista = request.getParameter("identificador");
		   if(idPista==null){
			   pagina="modificarPista";
			   popup=true;
			   addActionMessage("No ha seleccionado ninguna pista");
			   return ERROR;
		   }
		   idPista = idPista.replace("/", "");
		 
		  pagina="nuevaPista?idpista="+idPista;
		  sesion.put("volver", "true"); 
		  popup = false;
		  
		  return SUCCESS;

	   }
	  
	  public String borrar() {
	
		   String idPista = request.getParameter("identificador");
		   if(idPista==null){
			   pagina="modificarPista";
			   popup=true;
			   addActionMessage("No ha seleccionado ninguna pista");
			   return ERROR;
		   }
		   idPista = idPista.replace("/", "");
		  
		  try {
			pista = pistaControler.getPista(idPista);
			pistaControler.borrarPista(pista);
		  } catch (Exception e) {
				log.error(e);
				e.printStackTrace();
		  }
			  
		  pagina="modificarPista";
		  popup = true;
		  addActionMessage("Pista borrada correctamente");
		  log.info("Pista borrada correctamente con id: "+pista.getIdPista());
		  return SUCCESS;

	   }
	  
	public List<Pista> getPistas(){
		return pistas;
	}

	public PistaControler getPistaControler() {
		return pistaControler;
	}

	public void setPistaControler(PistaControler pistaControler) {
		this.pistaControler = pistaControler;
	}

	public String getPagina() {
		return pagina;
	}

	public void setPagina(String pagina) {
		this.pagina = pagina;
	}

	public Boolean getPopup() {
		return popup;
	}

	public void setPopup(Boolean popup) {
		this.popup = popup;
	}

	public void setPista(Pista pista) {
		this.pista = pista;
	}

	public Pista getPista() {
		return pista;
	}

	@Override
	public Pista getModel() {
		return pista;
	}
	
	
	  
	  

}
