package action.login;

import org.apache.struts2.dispatcher.SessionMap;

import action.BaseAction;
import beans.Persona;

import com.opensymphony.xwork2.ActionContext;

import controler.PersonaControler;
import controler.impl.PersonaControlerImpl;

public class LoginAction extends BaseAction {

	/**
	 * 
	 */

	private static final long serialVersionUID = 1L;
	private String nombre;
	private String pass;
	private PersonaControler personaControler;
	private Boolean popup = false;

	public String execute() {

		personaControler = (PersonaControler) applicationContext.getBean(
				"personaControler", PersonaControlerImpl.class);

		Persona user = null;
		try {
			user = personaControler.getPersonaLogin(nombre, pass);
		} catch (Exception e) {
			log.error(e);
			e.printStackTrace();
		}

		if (user != null) {
			if (!user.isActivo()) {
				addActionError("Usuario bloqueado, consulte con el administrador.");
				log.error("Usuario bloqueado, consulte con el administrador.");
				popup = false;
				return ERROR;
			} else {
				sesion.put("sessionUser", user);
				log.info("Acceso correcto para el usuario: "+user);
				popup = false;
				return SUCCESS;
			}
		} else {
			addActionError("Usuario o contrasea incorrectos");
			log.error("Usuario o contrasea incorrectos");
			popup = false;
			return ERROR;
		}
	}

	@SuppressWarnings("rawtypes")
	public String exit() throws Exception {
		sesion.remove("sessionUser");
		sesion.clear();
		SessionMap session = (SessionMap) ActionContext.getContext()
				.getSession();

		session.invalidate();
		log.info("Usuario fuera de la aplicacin");
		return SUCCESS;
	}

	public void setPersonaControler(PersonaControler controler) {
		this.personaControler = controler;
	}

	public PersonaControler getPersonaControler() {
		return personaControler;
	}

	public String getNombre() {
		return nombre;
	}

	public String getPass() {
		return pass;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public void setPass(String pass) {
		this.pass = pass;
	}

	public Boolean getPopup() {
		return popup;
	}

	public void setPopup(Boolean popup) {
		this.popup = popup;
	}

}
