package action.profesor;

import java.util.Date;
import java.util.List;

import action.BaseAction;
import beans.Asistencia;
import beans.Curso;
import beans.Matricula;
import beans.Persona;
import controler.CursoControler;
import controler.impl.CursoControlerImpl;



public class CursosProfesorAction  extends BaseAction  {

	 /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private List<Curso> clases;
	private List<Matricula> matriculas;
	private List<Asistencia> asistencias;
	private CursoControler cursoControler;
	private String idCurso;
	private String pagina = null;
	private Boolean popup = false;

	   public String execute() {
				   
		  cursoControler =  (CursoControler) applicationContext.getBean("cursoControler",CursoControlerImpl.class);
		  try {
				clases = cursoControler.getCursosProfesor((Persona) sesion.get("sessionUser"));
			} catch (Exception e) {
				log.error(e);
				e.printStackTrace();
			}
		  popup = false;

		  return SUCCESS;

	   }
	   
	   public String consulta(){
		  
		   idCurso = request.getParameter("identificador");
		   if(idCurso==null){
			   pagina="consultaCursosProfesor";
			   popup=true;
			   addActionMessage("No ha seleccionado ningn curso");
			   return ERROR;
		   }
		   idCurso = idCurso.replace("/", "");
		   
		   cursoControler =  (CursoControler) applicationContext.getBean("cursoControler",CursoControlerImpl.class);				 
		   
		   try {
				matriculas = cursoControler.getMatriculasCurso(idCurso);
			} catch (Exception e) {
				log.error(e);
				e.printStackTrace();
			}
		   
		   popup=false;
		   
		   return SUCCESS;
	   }
	   
	   public String consultaAsistenciaUltimaFecha(){

		   idCurso = request.getParameter("identificador");
		   if(idCurso==null){
			   pagina="consultaCursosProfesor";
			   popup=true;
			   addActionMessage("No ha seleccionado ningn curso");
			   return ERROR;
		   }
		   idCurso = idCurso.replace("/", "");
		   
		   cursoControler =  (CursoControler) applicationContext.getBean("cursoControler",CursoControlerImpl.class);				 
		   
		   try {
				asistencias = cursoControler.getAsistenciaCurso(idCurso);
			} catch (Exception e) {
				log.error(e);
				e.printStackTrace();
			}
		   
		   popup=false;
		   
		   return SUCCESS;
	   }
	   
	   public String grabar(){
		   
		   cursoControler =  (CursoControler) applicationContext.getBean("cursoControler",CursoControlerImpl.class);
		   try{
		   String alumnosAsistentes = request.getParameter("alumnosAsistentes");
		   Date fecha = cursoControler.ultimaFechaCurso(idCurso);
		   if(cursoControler.existeAsistencia(idCurso, fecha)){
			   popup=true;
			   addActionMessage("La ltima clase ya tiene asistencia generada");
			   log.error("La ltima clase ya tiene asistencia generada");
			   pagina="generarAsistenciaCursos";
		   }else{
			   String[] alumnos = alumnosAsistentes.split(";");
			   for(int i=0;i<alumnos.length;i++){
				   cursoControler.marcarAsistencia(alumnos[i], idCurso, fecha);
			   }
			   popup=true;
			   addActionMessage("Asistencia generada correctamente");
			   log.info("Asistencia generada correctamente para el curso con id: "+idCurso);
			   pagina="generarAsistenciaCursos";
		   }
		   }catch(Exception e){
			   log.error(e);
			   e.printStackTrace();
		   }
		   
		   return SUCCESS;
	   }

	public List<Curso> getClases() {
		return clases;
	}

	public void setClases(List<Curso> clases) {
		this.clases = clases;
	}
	
	public List<Matricula> getMatriculas() {
		return matriculas;
	}

	public void setMatriculas(List<Matricula> matriculas) {
		this.matriculas = matriculas;
	}

	public List<Asistencia> getAsistencias() {
		return asistencias;
	}

	public void setAsistencias(List<Asistencia> asistencias) {
		this.asistencias = asistencias;
	}

	public CursoControler getCursoControler() {
		return cursoControler;
	}

	public void setCursoControler(CursoControler cursoControler) {
		this.cursoControler = cursoControler;
	}

	public String getPagina(){
		return pagina;
	}
	public Boolean getPopup(){
		return popup;
	}
	public void setPopup(Boolean popup){
		this.popup = popup;
	}

	public String getIdCurso() {
		return idCurso;
	}

	public void setIdCurso(String idCurso) {
		this.idCurso = idCurso;
	}
	   
	
}
