package action.usuario;

import java.util.Date;
import java.util.List;

import com.opensymphony.xwork2.ModelDriven;

import action.BaseAction;
import beans.Alquiler;
import beans.Persona;
import beans.Pista;
import controler.AlquilerControler;
import controler.impl.AlquilerControlerImpl;

@SuppressWarnings("serial")
public class AlquilerPistaAction extends BaseAction implements ModelDriven<Alquiler> {
	
	private AlquilerControler alquilerControler;
	Alquiler alquiler = new Alquiler();
	private List<Pista> pistas;
	private Date fechaAlquiler = new Date();
	String pagina;
	Boolean popup;
	private String idAlquiler;

	public String getPagina() {
		return pagina;
	}

	public void setPagina(String pagina) {
		this.pagina = pagina;
	}

	public Boolean getPopup() {
		return popup;
	}

	public void setPopup(Boolean popup) {
		this.popup = popup;
	}

	public String execute() {

		  alquilerControler =  (AlquilerControler) applicationContext.getBean("alquilerControler",AlquilerControlerImpl.class);

		  try {
			  pistas = alquilerControler.getPistas();
		
			  popup = false;
			  idAlquiler = request.getParameter("idalquiler");
			  if(idAlquiler!=null){
				  alquiler = alquilerControler.getAlquiler(idAlquiler);
			  }
		  } catch (Exception e) {
			    log.error(e);
				e.printStackTrace();
		  }
		  return SUCCESS;

	   }
	
	public String grabar() {

		  alquilerControler =  (AlquilerControler) applicationContext.getBean("alquilerControler",AlquilerControlerImpl.class);
		
		  try {
			  pistas = alquilerControler.getPistas();
			  
			  String idPista = request.getParameter("selectPistas");
			  String fechaAlquiler = request.getParameter("fechaAlquiler");
			  String horaInicio = request.getParameter("horaInicio");
			  String minutoInicio = request.getParameter("minutoInicio");
			  String horaFin = request.getParameter("horaFin");
			  String minutoFin = request.getParameter("minutoFin");
			  int inicio = Integer.parseInt(horaInicio)+Integer.parseInt(minutoInicio);
			  int fin = Integer.parseInt(horaInicio)+Integer.parseInt(minutoFin);
			  if(idPista==null||"0".equals(idPista)){
				  pagina="alquilerPista";
				  popup=true;
				  addActionMessage("Debe seleccionar una pista");
			  }else if(fechaAlquiler==null||"".equals(fechaAlquiler)){
				  pagina="alquilerPista";
				  popup=true;
				  addActionMessage("Debe seleccionar una fecha de alquiler");
			  }else if(inicio>=fin){
				  pagina="alquilerPista";
				  popup=true;
				  addActionMessage("Debe seleccionar una hora correcta de alquiler");
			  }else{
				   
				  Persona alquilador = (Persona) sesion.get("sessionUser");
				  String idAlquiler=request.getParameter("idAlquiler");
				  if(idAlquiler!=null){//Venimos de modificar
					  alquiler = alquilerControler.getAlquiler(idAlquiler);
					  alquilerControler.borrarAlquiler(idAlquiler);//Eliminamos el alquiler que ya hubiese
				  }
				 
				  if(alquilerControler.pistaOcupada(fechaAlquiler, horaInicio, minutoInicio, horaFin, minutoFin, idPista)){
					  if(idAlquiler!=null)
						  alquilerControler.alquiler(alquiler);//Si en la hora elegida hubiese algo ya alquilado, no se modificar, con lo cual regeneramos el alquiler que nos hubiesemos cargado
					  pagina="alquilerPista";
					  popup=true;
					  addActionMessage("Pista ocupada en el intervalo de tiempo elegido");
				  }else{
					  alquilerControler.alquiler(idPista, fechaAlquiler, horaInicio, minutoInicio, horaFin, minutoFin, alquilador);
					  String volver = (String) sesion.get("volver");
					   if("true".equals(volver)){
						   pagina = "modificacionAlquilarPista";
						   sesion.remove("volver");
					   }else{
						   pagina = "alquilerPista";
					   }
				
					  popup=true;
					  addActionMessage("Alquiler realizado correctamente");
					  log.info("Alquiler realizado correctamente con id: "+alquiler.getIdAlquiler());
				  }
			  }
			} catch (Exception e) {
				log.error(e);
				e.printStackTrace();
			}
		  return SUCCESS;

	   }

	public List<Pista> getPistas() {
		return pistas;
	}


	public void setPistas(List<Pista> pistas) {
		this.pistas = pistas;
	}


	public AlquilerControler getAlquilerControler() {
		return alquilerControler;
	}

	public void setAlquilerControler(AlquilerControler alquilerControler) {
		this.alquilerControler = alquilerControler;
	}


	public Date getFechaAlquiler() {
		return fechaAlquiler;
	}


	public void setFechaAlquiler(Date fechaAlquiler) {
		this.fechaAlquiler = fechaAlquiler;
	}

	public Alquiler getAlquiler() {
		return alquiler;
	}

	public void setAlquiler(Alquiler alquiler){
		this.alquiler=alquiler;
	}
	@Override
	public Alquiler getModel() {
		return alquiler;
	}
	
	
}
