package action.usuario;

import java.util.List;

import action.BaseAction;
import beans.Curso;
import beans.Persona;
import controler.CursoControler;
import controler.impl.CursoControlerImpl;



public class InscripcionCursoAction  extends BaseAction  {

	 /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private List<Curso> cursos;
	private CursoControler cursoControler;
	private String pagina = null;
	private Boolean popup = false;

	   public String execute() {

		  cursoControler =  (CursoControler) applicationContext.getBean("cursoControler",CursoControlerImpl.class);

		  try {
			  cursos = cursoControler.getCursosLibres((Persona) sesion.get("sessionUser"));
			} catch (Exception e) {
				log.error(e);
				e.printStackTrace();
			}
		  popup = false;
 
		  return SUCCESS;

	   }
	   
	   public String grabar(){

		   String idCurso = request.getParameter("identificador");
		   if(idCurso==null){
			   pagina="modificacionInscripcionCurso";
			   popup=true;
			   addActionMessage("No ha seleccionado ningn curso");
			   return ERROR;
		   }
		   idCurso = idCurso.replace("/", "");

		   cursoControler =  (CursoControler) applicationContext.getBean("cursoControler",CursoControlerImpl.class);

		   Persona alumno = (Persona) sesion.get("sessionUser");
		   String idMatricula = (String) sesion.get("idMatricula");
		   
		   try {
			cursoControler.borrarAlumnoDeCurso(idMatricula);
		
		    cursoControler.inscribirAlumnoEnCurso(alumno, idCurso);
		   } catch (Exception e) {
				log.error(e);
				e.printStackTrace();
		   }  
		   
		   String volver = (String) sesion.get("volver");
		   if("true".equals(volver)){
			   pagina = "modificacionInscripcionCurso";
			   sesion.remove("volver");
		   }else{
			   pagina = "inscripcionCurso";
		   }
		   popup=true;
		   addActionMessage("Inscripcin realizada correctamente");
		   log.info("Inscripcin realizada correctamente con id: "+idMatricula);
		   return SUCCESS;
	   }

	public List<Curso> getCursos() {
		return cursos;
	}

	public void setCursos(List<Curso> cursos) {
		this.cursos = cursos;
	}

	public CursoControler getCursoControler() {
		return cursoControler;
	}

	public void setCursoControler(CursoControler cursoControler) {
		this.cursoControler = cursoControler;
	}

	public String getPagina(){
		return pagina;
	}
	public Boolean getPopup(){
		return popup;
	}
	public void setPopup(Boolean popup){
		this.popup = popup;
	}
	   
}
