package action.usuario;

import java.util.List;

import action.BaseAction;
import beans.Alquiler;
import beans.Persona;
import controler.AlquilerControler;
import controler.impl.AlquilerControlerImpl;

@SuppressWarnings("serial")
public class ModificarAlquilerPistaAction extends BaseAction {
	
	private AlquilerControler alquilerControler;
	private List<Alquiler> alquileres;
	String pagina;
	Boolean popup;

	public String execute() {
		   
		  alquilerControler =  (AlquilerControler) applicationContext.getBean("alquilerControler",AlquilerControlerImpl.class);
		   
		  Persona alquilador = (Persona) sesion.get("sessionUser");
		  
		  try {
			  alquileres = alquilerControler.getAlquileresPersona(alquilador);
			} catch (Exception e) {
				log.error(e);
				e.printStackTrace();
			}
		  		  
		  return SUCCESS;

	   }
	
	public String modificar(){

		   String idAlquiler = request.getParameter("identificador");
		   if(idAlquiler==null){
			   pagina="modificacionAlquilarPista";
			   popup=true;
			   addActionMessage("No ha seleccionado ningn alquiler");
			   return ERROR;
		   }
		   idAlquiler = idAlquiler.replace("/", "");		  
		   
		   pagina="alquilerPista?idalquiler="+idAlquiler;
		   sesion.put("volver", "true"); 
		   addActionMessage("Alquiler modificado correctamente");
		   log.info("Alquiler modificado correctamente con id: "+idAlquiler);
		   return SUCCESS;
	   }
	   
	   public String borrar(){

		   String idAlquiler = request.getParameter("identificador");
		   if(idAlquiler==null){
			   pagina="modificacionAlquilarPista";
			   popup=true;
			   addActionMessage("No ha seleccionado ningn alquiler");
			   return ERROR;
		   }
		   idAlquiler = idAlquiler.replace("/", "");

		   alquilerControler =  (AlquilerControler) applicationContext.getBean("alquilerControler",AlquilerControlerImpl.class);			  
		   
		   try {
				alquilerControler.borrarAlquiler(idAlquiler);
			} catch (Exception e) {
				log.error(e);
				e.printStackTrace();
			}
		   
		   pagina="modificacionAlquilarPista";
		   popup=true;
		   addActionMessage("Alquiler borrado correctamente");
		   log.info("Alquiler borrado correctamente con id: "+idAlquiler);
		   return SUCCESS;
	   }
	
	public String getPagina() {
		return pagina;
	}

	public void setPagina(String pagina) {
		this.pagina = pagina;
	}

	public Boolean getPopup() {
		return popup;
	}

	public void setPopup(Boolean popup) {
		this.popup = popup;
	}

	public List<Alquiler> getAlquileres() {
		return alquileres;
	}

	public void setAlquileres(List<Alquiler> alquileres) {
		this.alquileres = alquileres;
	}
	
	

}
