package action.usuario;

import java.util.List;

import action.BaseAction;
import beans.Matricula;
import beans.Persona;
import controler.CursoControler;
import controler.impl.CursoControlerImpl;



public class ModificarInscripcionCursoAction  extends BaseAction  {

	 /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private List<Matricula> matriculas;
	private CursoControler cursoControler;
	private String pagina = null;
	private Boolean popup = false;

	   public String execute() {

		  cursoControler =  (CursoControler) applicationContext.getBean("cursoControler",CursoControlerImpl.class);

		  try {
				matriculas = cursoControler.getMatriculasAlumno((Persona) sesion.get("sessionUser"));
			} catch (Exception e) {
				log.error(e);
				e.printStackTrace();
			}
		  popup = false;
		  return SUCCESS;
	   }
	   
	   public String grabar() throws Exception{

		   String idMatricula = request.getParameter("identificador");
		   if(idMatricula==null){
			   pagina="modificacionInscripcionCurso";
			   popup=true;
			   addActionMessage("No ha seleccionado ningn curso");
			   return ERROR;
		   }
		   idMatricula = idMatricula.replace("/", "");

		   pagina="inscripcionCurso";
		   sesion.put("volver", "true");  
		   sesion.put("idMatricula", idMatricula);

		   addActionMessage("Inscripcin modificada correctamente");
		   log.info("Inscripcin modificada correctamente con id: "+idMatricula);
		   return SUCCESS;
	   }
	   
	   public String borrar(){

		   String idMatricula = request.getParameter("identificador");
		   if(idMatricula==null){
			   pagina="modificacionInscripcionCurso";
			   popup=true;
			   addActionMessage("No ha seleccionado ningn curso");
			   return ERROR;
		   }
		   idMatricula = idMatricula.replace("/", "");
		   
		   cursoControler =  (CursoControler) applicationContext.getBean("cursoControler",CursoControlerImpl.class);
		   
		   try {
				cursoControler.borrarAlumnoDeCurso(idMatricula);
			} catch (Exception e) {
				log.error(e);
				e.printStackTrace();
			}
		   
		   pagina="modificacionInscripcionCurso";
		   popup=true;
		   addActionMessage("Inscripcin borrada correctamente");
		   log.info("Inscripcin modificada correctamente con id: "+idMatricula);
		   return SUCCESS;
	   }

	public List<Matricula> getMatriculas() {
		return matriculas;
	}

	public void setCursos(List<Matricula> matriculas) {
		this.matriculas = matriculas;
	}

	public CursoControler getCursoControler() {
		return cursoControler;
	}

	public void setCursoControler(CursoControler cursoControler) {
		this.cursoControler = cursoControler;
	}

	public String getPagina(){
		return pagina;
	}
	public Boolean getPopup(){
		return popup;
	}
	public void setPopup(Boolean popup){
		this.popup = popup;
	}
	   
}
