package beans;

import java.sql.Time;
import java.text.SimpleDateFormat;
import java.util.Date;

public class Curso {
	
	Integer idCurso;
	String nombre;
	Pista pista;
	Date fechaInicio;
	Date fechaFin;
	Boolean lunes;
	Boolean martes;
	Boolean miercoles;
	Boolean jueves;
	Boolean viernes;
	Integer plazasDisponibles;
	Time horaIniCurso;
	Time horaFinCurso;
	Persona profesor;
	
	public Integer getPlazasDisponibles() {
		return plazasDisponibles;
	}
	public void setPlazasDisponibles(Integer plazasDisponibles) {
		this.plazasDisponibles = plazasDisponibles;
	}
	public Integer getIdCurso() {
		return idCurso;
	}
	public void setIdCurso(Integer idCurso) {
		this.idCurso = idCurso;
	}
	public String getNombre() {
		return nombre;
	}
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}
	public Pista getPista() {
		return pista;
	}
	public void setPista(Pista pista) {
		this.pista = pista;
	}
	public Date getFechaInicio() {
		return fechaInicio;
	}
	public String getFechaInicioFormat() {
		String patron = "dd/MM/yyyy";
		SimpleDateFormat formato = new SimpleDateFormat(patron);
		String fecha = formato.format(fechaInicio);
		return fecha;
	}
	public void setFechaInicio(Date fechaInicio) {
		this.fechaInicio = fechaInicio;
	}
	public Date getFechaFin() {
		return fechaFin;
	}
	public String getFechaFinFormat(){
		String patron = "dd/MM/yyyy";
		SimpleDateFormat formato = new SimpleDateFormat(patron);
		String fecha = formato.format(fechaFin);
		return fecha;
	}
	public void setFechaFin(Date fechaFin) {
		this.fechaFin = fechaFin;
	}
	public Boolean getLunes() {
		return lunes;
	}
	public void setLunes(Boolean lunes) {
		this.lunes = lunes;
	}
	public Boolean getMartes() {
		return martes;
	}
	public void setMartes(Boolean martes) {
		this.martes = martes;
	}
	public Boolean getMiercoles() {
		return miercoles;
	}
	public void setMiercoles(Boolean miercoles) {
		this.miercoles = miercoles;
	}
	public Boolean getJueves() {
		return jueves;
	}
	public void setJueves(Boolean jueves) {
		this.jueves = jueves;
	}
	public Boolean getViernes() {
		return viernes;
	}
	public void setViernes(Boolean viernes) {
		this.viernes = viernes;
	}	
	public String getDiasFormateados(){
		String devolver = "";
		
		if(this.lunes){
			devolver+="L";
		}else{
			devolver+=" ";
		}
		if(this.martes){
			devolver+="M";
		}else{
			devolver+=" ";
		}
		if(this.miercoles){
			devolver+="X";
		}else{
			devolver+=" ";
		}
		if(this.jueves){
			devolver+="J";
		}else{
			devolver+=" ";
		}
		if(this.viernes){
			devolver+="V";
		}else{
			devolver+=" ";
		}
		
		return devolver;
	}
	public Time getHoraIniCurso() {
		return horaIniCurso;
	}
	public void setHoraIniCurso(Time horaIniCurso) {
		this.horaIniCurso = horaIniCurso;
	}
	public String getHoraIniCursoFormat(){
		String patron = "kk:mm";
		SimpleDateFormat formato = new SimpleDateFormat(patron);
		String hora = formato.format(horaIniCurso);
		return hora;
	}
	public String getHoraIniFormat(){
		String horaCompleta = getHoraIniCursoFormat();
		String partes[] = horaCompleta.split(":");
		return partes[0];
	}
	public String getMinutoIniFormat(){
		String horaCompleta = getHoraIniCursoFormat();
		String partes[] = horaCompleta.split(":");
		return partes[1];
	}
	public String getHoraFinFormat(){
		String horaCompleta = getHoraFinCursoFormat();
		String partes[] = horaCompleta.split(":");
		return partes[0];
	}
	public String getMinutoFinFormat(){
		String horaCompleta = getHoraFinCursoFormat();
		String partes[] = horaCompleta.split(":");
		return partes[1];
	}
	public Time getHoraFinCurso() {
		return horaFinCurso;
	}
	public void setHoraFinCurso(Time horaFinCurso) {
		this.horaFinCurso = horaFinCurso;
	}
	public String getHoraFinCursoFormat(){
		String patron = "kk:mm";
		SimpleDateFormat formato = new SimpleDateFormat(patron);
		String hora = formato.format(horaFinCurso);
		return hora;
	}
	public Persona getProfesor() {
		return profesor;
	}
	public void setProfesor(Persona profesor) {
		this.profesor = profesor;
	}
	public String toString(){
		return this.nombre;
	}
	public boolean equals(Object obj){
		return this.getIdCurso()==((Curso) obj).getIdCurso();
	}
}
