package controler;

import java.util.Date;
import java.util.List;

import beans.Asistencia;
import beans.Curso;
import beans.Matricula;
import beans.Persona;
import beans.Pista;


public interface CursoControler {
	
	public Curso getCurso(String idCurso) throws Exception;
	
	public List<Curso> getCursos() throws Exception;
	
	public List<Curso> getCursosLibres(Persona alumno) throws Exception;

	public void inscribirAlumnoEnCurso(Persona alumno, String idCurso) throws Exception;
	
	public List<Matricula> getMatriculasAlumno(Persona alumno) throws Exception;
	
	public void borrarAlumnoDeCurso(String idCurso) throws Exception;
	
	public List<Curso> getCursosProfesor(Persona profesor) throws Exception;
	
	public List<Matricula> getMatriculasCurso(String idCurso) throws Exception;
	
	public Date ultimaFechaCurso(String idCurso) throws Exception;
	
	public Boolean existeAsistencia(String idCurso, Date fechaAsistencia) throws Exception;
	
	public void marcarAsistencia(String idAlumno, String idCurso, Date fechaAsistencia) throws Exception;
	
	public void guardarCurso(Curso curso) throws Exception;
	
	public void borrarCurso(Curso curso) throws Exception;
	
	public List<Asistencia> getAsistenciaCurso(String idCurso) throws Exception;
	
	public List<Pista> getPistas() throws Exception;
	
	public List<Persona> getProfesores() throws Exception;
	
}
