package controler.impl;

import java.sql.Time;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

import utils.TimeUtil;

import beans.Alquiler;
import beans.Persona;
import beans.Pista;
import controler.AlquilerControler;
import dao.AlquilerDAO;
import dao.PistaDAO;

public class AlquilerControlerImpl implements AlquilerControler {

	private PistaDAO pistaDAO;
	private AlquilerDAO alquilerDAO;
	
	public void setPistaDAO(PistaDAO pistaDAO) {
		this.pistaDAO = pistaDAO;
	}
	public void setAlquilerDAO(AlquilerDAO alquilerDAO) {
		this.alquilerDAO = alquilerDAO;
	}
	@Override
	public List<Pista> getPistas() throws Exception {		
		return pistaDAO.getPistas();
	}
	
	public void alquiler(Alquiler Alquiler) throws Exception{
		alquilerDAO.alquilarPista(Alquiler);
	}
	@Override
	public void alquiler(String idPista, String fechaAlquiler,
			String horaInicio, String minutoInicio, String horaFin,
			String minutoFin, Persona alquilador) throws Exception {
		Alquiler alquiler = new Alquiler();
		Pista pista = pistaDAO.getPista(idPista);
		alquiler.setPista(pista);
		alquiler.setAlquilador(alquilador);
		SimpleDateFormat formatoDelTexto = new SimpleDateFormat("dd/MM/yyyy");
		Date dat = formatoDelTexto.parse(fechaAlquiler);
		alquiler.setFechaAlquiler(dat);
		alquiler.setHoraIniAlquiler(TimeUtil.StringToHora(horaInicio, minutoInicio));
		alquiler.setHoraFinAlquiler(TimeUtil.StringToHora(horaFin, minutoFin));
		
		alquilerDAO.alquilarPista(alquiler);
		
	}
	@Override
	public Boolean pistaOcupada(String fechaAlquiler, String horaInicio,
			String minutoInicio, String horaFinal, String minutoFinal, String idPista)
			throws Exception {
		SimpleDateFormat formatoDelTexto = new SimpleDateFormat("dd/MM/yyyy");
		Date fecha = formatoDelTexto.parse(fechaAlquiler);
		
		Time horaIni = TimeUtil.StringToHora(horaInicio, minutoInicio);
		Time horaFin = TimeUtil.StringToHora(horaFinal, minutoFinal);
		return alquilerDAO.pistaOcupada(fecha, horaIni, horaFin, idPista);
	}

	public List<Alquiler> getAlquileresPersona(Persona alquilador) throws Exception{
		return alquilerDAO.getAlquileresPersona(alquilador);
	}
	public Alquiler getAlquiler(String idAlquiler) throws Exception{
		return alquilerDAO.getAlquiler(idAlquiler);
	}
	@Override
	public void borrarAlquiler(String idAlquiler) throws Exception {
		Alquiler alquiler = alquilerDAO.getAlquiler(idAlquiler);
		alquilerDAO.borrarAlquiler(alquiler);
	}
}
