package dao.impl;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.SQLQuery;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.criterion.Expression;

import beans.Persona;
import dao.BaseDAO;
import dao.PersonaDAO;

public class PersonaDAOImpl extends BaseDAO implements PersonaDAO{

	public Persona getUserLogin(String dni, String password) throws Exception {

		String devolver = null;

		Session session = null;
		Persona user = null;
		Transaction tx = null;

		try {
		   session = sessionFactory.openSession();
		   tx = session.beginTransaction();
		   Criteria crit = session.createCriteria(Persona.class);
		   crit.add(Expression.eq("dni",dni));
		   crit.add(Expression.eq("password",password));
		   @SuppressWarnings("unchecked")
		   List<Persona> users = crit.list();
		   if(!users.isEmpty()){
			   user = (Persona) users.get(0);
			   devolver = user.getNombre()+" "+user.getApellidos();
			   System.out.println(devolver);
		   }

		   tx.commit();
		}
		catch(Exception e) {
		   if (tx != null)    {
		      try  {
		         tx.rollback();
		      }
		      catch (HibernateException e1)  {
		    	  log.error(e1);
		         throw new Exception(e1);
		      }
		   }
		   log.error(e);
		   throw new Exception(e);
		}
		finally {
		   if (session != null) {
		      try {
		         session.close();
		      }
		      catch (HibernateException e)  {
		    	  log.error(e);
		      }
		   }
		}
		return user;
	}
	
	public Persona getPersona(String idPersona) throws Exception {

		Session session = null;
		Persona user = null;
		Transaction tx = null;

		try {
		   session = sessionFactory.openSession();
		   tx = session.beginTransaction();		   

		   Criteria crit = session.createCriteria(Persona.class);
		   crit.add(Expression.eq("idPersona",Integer.parseInt(idPersona)));		   
		   @SuppressWarnings("unchecked")
		   List<Persona> users = crit.list();
		   if(!users.isEmpty()){
			   user = (Persona) users.get(0);
		   }

		   tx.commit();
		}
		catch(Exception e) {
		   if (tx != null)    {
		      try  {
		         tx.rollback();
		      }
		      catch (HibernateException e1)  {
		    	  log.error(e1);
		         throw new Exception(e1);
		      }
		   }
		   log.error(e);
		   throw new Exception(e);
		}
		finally {
		   if (session != null) {
		      try {
		         session.close();
		      }
		      catch (HibernateException e)  {
		    	  log.error(e);
		      }
		   }
		}
		return user;
	}
	
	@SuppressWarnings("unchecked")
	public List<Persona> getPersonas() throws Exception {

		Session session = null;
		Transaction tx = null;
		List<Persona> users = null;
		try {
		   session = sessionFactory.openSession();
		   tx = session.beginTransaction();		   

		   Criteria crit = session.createCriteria(Persona.class);		   
		   users = crit.list();
		
		   tx.commit();
		}
		catch(Exception e) {
		   if (tx != null)    {
		      try  {
		         tx.rollback();
		      }
		      catch (HibernateException e1)  {
		    	  log.error(e1);
		         throw new Exception(e1);
		      }
		   }
		   log.error(e);
		   throw new Exception(e);
		}
		finally {
		   if (session != null) {
		      try {
		         session.close();
		      }
		      catch (HibernateException e)  {
		    	  log.error(e);
		      }
		   }
		}
		return users;
	}
	
	@SuppressWarnings("unchecked")
	public List<Persona> getProfesores() throws Exception {

		Session session = null;
		Transaction tx = null;
		List<Persona> users = null;
		try {
		   session = sessionFactory.openSession();
		   tx = session.beginTransaction();		   

		   Criteria crit = session.createCriteria(Persona.class);
		   crit.add(Expression.eq("rol","profesor"));		   
		   users = crit.list();
		
		   tx.commit();
		}
		catch(Exception e) {
		   if (tx != null)    {
		      try  {
		         tx.rollback();
		      }
		      catch (HibernateException e1)  {
		    	  log.error(e1);
		         throw new Exception(e1);
		      }
		   }
		   log.error(e);
		   throw new Exception(e);
		}
		finally {
		   if (session != null) {
		      try {
		         session.close();
		      }
		      catch (HibernateException e)  {
		    	  log.error(e);
		      }
		   }
		}
		return users;
	}
	
	public void guardarPersona(Persona persona) throws Exception {
		Session session = null;
		Transaction tx = null;

		try {
		   session = sessionFactory.openSession();
		   tx = session.beginTransaction();

		   session.saveOrUpdate(persona);

		   tx.commit();
		}
		catch(Exception e) {
		   if (tx != null)    {
		      try  {
		         tx.rollback();
		      }
		      catch (HibernateException e1)  {
		    	  log.error(e1);
		         throw new Exception(e1);
		      }
		   }
		   log.error(e);
		   throw new Exception(e);
		}
		finally {
		   if (session != null) {
		      try {
		         session.close();
		      }
		      catch (HibernateException e)  {
		    	  log.error(e);
		      }
		   }
		}
	}
	
	public void borrarPersona(Persona persona) throws Exception {
		Session session = null;
		Transaction tx = null;

		try {
		   session = sessionFactory.openSession();
		   tx = session.beginTransaction();

		   session.delete(persona);


		   tx.commit();
		}
		catch(Exception e) {
		   if (tx != null)    {
		      try  {
		         tx.rollback();
		      }
		      catch (HibernateException e1)  {
		    	  log.error(e1);
		         throw new Exception(e1);
		      }
		   }
		   log.error(e);
		   throw new Exception(e);
		}
		finally {
		   if (session != null) {
		      try {
		         session.close();
		      }
		      catch (HibernateException e)  {
		    	  log.error(e);
		      }
		   }
		}
	}
	
	@SuppressWarnings("unchecked")
	public List<String> getRoles() throws Exception{
		Session session = null;
		Transaction tx = null;
		List<String> roles = null;
		try {
		   session = sessionFactory.openSession();
		   tx = session.beginTransaction();		   

		  SQLQuery query = session.createSQLQuery("Select tipopersona from tipopersona");
		  roles = query.list();
		
		  tx.commit();
		}
		catch(Exception e) {
		   if (tx != null)    {
		      try  {
		         tx.rollback();
		      }
		      catch (HibernateException e1)  {
		    	  log.error(e1);
		         throw new Exception(e1);
		      }
		   }
		   throw new Exception(e);
		}
		finally {
		   if (session != null) {
		      try {
		         session.close();
		      }
		      catch (HibernateException e)  {
		    	  log.error(e);
		      }
		   }
		}
		return roles;
	}

}
