package dao.impl;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.criterion.Expression;

import beans.Pista;
import dao.BaseDAO;
import dao.PistaDAO;

public class PistaDAOImpl extends BaseDAO implements PistaDAO{
	
	@SuppressWarnings("unchecked")
	public List<Pista> getPistas() throws Exception{
		Session session = null;
		Transaction tx = null;
		List<Pista> devolver = null;

		try {
		   session = sessionFactory.openSession();
		   tx = session.beginTransaction();

		   Criteria crit = session.createCriteria(Pista.class);

		   devolver = crit.list();


		   tx.commit();
		}
		catch(Exception e) {
		   if (tx != null)    {
		      try  {
		         tx.rollback();
		      }
		      catch (HibernateException e1)  {
		    	  log.error(e1);
		         throw new Exception(e1);
		      }
		   }
		   log.error(e);
		   throw new Exception(e);
		}
		finally {
		   if (session != null) {
		      try {
		         session.close();
		      }
		      catch (HibernateException e)  {
		    	  log.error(e);
		      }
		   }
		}
		return devolver;
	}

	@Override
	public Pista getPista(String idPista) throws Exception {
		Session session = null;
		Transaction tx = null;
		Pista pista = null;

		try {
		   session = sessionFactory.openSession();
		   tx = session.beginTransaction();

		   Criteria crit = session.createCriteria(Pista.class);
		   crit.add(Expression.eq("idPista",Integer.parseInt(idPista)));
		   pista = (Pista) crit.list().get(0);


		   tx.commit();
		}
		catch(Exception e) {
		   if (tx != null)    {
		      try  {
		         tx.rollback();
		      }
		      catch (HibernateException e1)  {
		    	  log.error(e1);
		         throw new Exception(e1);
		      }
		   }
		   log.error(e);
		   throw new Exception(e);
		}
		finally {
		   if (session != null) {
		      try {
		         session.close();
		      }
		      catch (HibernateException e)  {
		    	  log.error(e);
		      }
		   }
		}
		return pista;
	}
	
	public void guardarPista(Pista pista) throws Exception {
		Session session = null;
		Transaction tx = null;

		try {
		   session = sessionFactory.openSession();
		   tx = session.beginTransaction();

		   session.saveOrUpdate(pista);

		   tx.commit();
		}
		catch(Exception e) {
		   if (tx != null)    {
		      try  {
		         tx.rollback();
		      }
		      catch (HibernateException e1)  {
		    	  log.error(e1);
		         throw new Exception(e1);
		      }
		   }
		   log.error(e);
		   throw new Exception(e);
		}
		finally {
		   if (session != null) {
		      try {
		         session.close();
		      }
		      catch (HibernateException e)  {
		    	  log.error(e);
		      }
		   }
		}
	}
	
	public void borrarPista(Pista pista) throws Exception {
		Session session = null;
		Transaction tx = null;

		try {
		   session = sessionFactory.openSession();
		   tx = session.beginTransaction();

		   session.delete(pista);


		   tx.commit();
		}
		catch(Exception e) {
		   if (tx != null)    {
		      try  {
		         tx.rollback();
		      }
		      catch (HibernateException e1)  {
		    	  log.error(e1);
		         throw new Exception(e1);
		      }
		   }
		   log.error(e);
		   throw new Exception(e);
		}
		finally {
		   if (session != null) {
		      try {
		         session.close();
		      }
		      catch (HibernateException e)  {
		    	  log.error(e);
		      }
		   }
		}
	}

	public Pista modificarPista(Pista pista) throws Exception {
		Session session = null;
		Transaction tx = null;

		try {
		   session = sessionFactory.openSession();
		   tx = session.beginTransaction();

		   session.update(pista);


		   tx.commit();
		}
		catch(Exception e) {
		   if (tx != null)    {
		      try  {
		         tx.rollback();
		      }
		      catch (HibernateException e1)  {
		    	  log.error(e1);
		         throw new Exception(e1);
		      }
		   }
		   log.error(e);
		   throw new Exception(e);
		}
		finally {
		   if (session != null) {
		      try {
		         session.close();
		      }
		      catch (HibernateException e)  {
		    	  log.error(e);
		      }
		   }
		}
		return pista;
	}

}
