package seguridad;

import java.net.URL;

import org.apache.log4j.Logger;
import org.apache.log4j.helpers.Loader;

import com.opensymphony.xwork2.Action;
import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionInvocation;
import com.opensymphony.xwork2.interceptor.AbstractInterceptor;

@SuppressWarnings("serial")
public class InterceptorSeguridad extends AbstractInterceptor 
{
	private String actionPermitido;
	private static final Logger log = Logger.getLogger(InterceptorSeguridad.class);
	@SuppressWarnings("unused")
	private URL url = Loader.getResource("log4j/log4j.properties");
	
    @SuppressWarnings("finally")
	@Override
    public String intercept(ActionInvocation actionInvocation) throws Exception
    {
    	String result = Action.LOGIN;
    	try{
    	String nombreAccion = (String) ActionContext.getContext().get(ActionContext.ACTION_NAME);
    	    if (actionInvocation.getInvocationContext().getSession().containsKey("sessionUser")||nombreAccion.equals(actionPermitido))
    	    {
    	        result = actionInvocation.invoke();
    	    }

    	}catch(Exception e){
    		log.error(e);
    	}finally{
    	    return result;
    	}
    }
    
    public void setActionPermitido(String actionPermitido){
    	this.actionPermitido=actionPermitido;
    }
}